import processing.serial.*;

Serial Port;
PImage img;
 int num = 314880;

int[] grayNum=new int[num]; 
int col = 384;
int row = 820;
int request = 0;

void setup()
{
  Port = new Serial(this, "COM5", 115200);  
  img = loadImage("lena_full.bmp");
//  size(img.width, img.height);
  size(384,820);
  img.resize(384,820);
  println(width,height);
}

void draw()
{
  PImage gray_img = createImage( img.width, img.height, RGB );
  image(img, 0, 0);

  for ( int y = 0; y < img.height; y++)
  {
    for ( int x = 0; x < img.width; x++)
    {
      int pos = x + y*img.width;
      color c = img.pixels[pos];
      float r = red( c );
      float g = green( c );
      float b = blue( c );
      float gray = 0.3 * r + 0.59 * g + 0.11 * b;
      gray_img.pixels[pos] = color(gray);
      grayNum[pos] = int(gray);
    }
  }
//  gray_img.updatePixels();

  image(gray_img, 0, 0);

calcErrorDiff();
  makeBitPattern();

    
// Send data
    for ( int i=0;i<12288; i++) {
      Port.write(grayNum[i]);      
    }
  
  while(request != 60) {}
  request = 0;
// Send data
    for ( int i=12288;i<24576; i++) {
      Port.write(grayNum[i]);      
    } 

  while(request != 60) {}
  request = 0;
// Send data
    for ( int i=24576;i<36864; i++) {
      Port.write(grayNum[i]);      
    } 

  while(request != 60) {}
  request = 0;
// Send data
    for ( int i=36864;i<39360; i++) {
      Port.write(grayNum[i]);      
    } 

}


void calcErrorDiff() {
  int error;
  float val;
  int pos;
  int tmp;

  for ( int y = 0; y < row; y++)
  {
    for ( int x =0; x < col; x++)
    {
      pos = x + (y*col);
      tmp = grayNum[pos];
      if ( tmp>127) {
        grayNum[pos] = 255;
        error = tmp - 255;
      } else {
        grayNum[pos] = 0;
        error = tmp;
      }
      if ( x < col-1 ) {
        val = float(error)*(7.0/16.0);        
        grayNum[pos+1] += int(val);
      }
      if ( x > 0 & y < row-1 ) {
        val =float(error)*(3.0/16.0); 
        grayNum[(x-1)+((y+1)*col)] += int(val);
      }
      if (x < col-1 & y < row-1 ) {
        val = float(error)*(1.0/16.0); 
        grayNum[x+1+((y+1)*col)] += int(val);
      }
      if ( y < row-1 ) {
        val = float(error)*(5.0/16.0); 
        grayNum[x+((y+1)*col)] += int(val);
      }
//               println(grayNum[pos]);        
    }
  }
}

void makeBitPattern() {
  int cnt;
  int bit;
  int savePos = 0;
  for ( cnt =0; cnt<num; cnt=cnt+8)
  {
    int c=0;
    for ( bit=0; bit<8; bit++)
    {
      c = c << 1;
      int pos = cnt + bit;
 //     println(d);
      int tmp = grayNum[pos];
      if (tmp == 255) {
        c += 1;
      }
    }
    grayNum[savePos]=c;
//      println(savePos);
//      println(grayNum[savePos]);
    savePos += 1;
  }
}

void serialEvent(Serial p) {
  if (Port.available()> 0) {
    request = Port.read();
  }
}

